// Copyright Red Hat

// Code generated by informer-gen. DO NOT EDIT.

package externalversions

import (
	"fmt"

	v1alpha1 "github.com/identitatem/idp-client-api/api/identitatem/v1alpha1"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	cache "k8s.io/client-go/tools/cache"
)

// GenericInformer is type of SharedIndexInformer which will locate and delegate to other
// sharedInformers based on type
type GenericInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() cache.GenericLister
}

type genericInformer struct {
	informer cache.SharedIndexInformer
	resource schema.GroupResource
}

// Informer returns the SharedIndexInformer.
func (f *genericInformer) Informer() cache.SharedIndexInformer {
	return f.informer
}

// Lister returns the GenericLister.
func (f *genericInformer) Lister() cache.GenericLister {
	return cache.NewGenericLister(f.Informer().GetIndexer(), f.resource)
}

// ForResource gives generic access to a shared informer of the matching type
// TODO extend this to unknown resources with a client pool
func (f *sharedInformerFactory) ForResource(resource schema.GroupVersionResource) (GenericInformer, error) {
	switch resource {
	// Group=identityconfig.identitatem.io, Version=v1alpha1
	case v1alpha1.SchemeGroupVersion.WithResource("authrealms"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Identityconfig().V1alpha1().AuthRealms().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("clusteroauths"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Identityconfig().V1alpha1().ClusterOAuths().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("idpconfigs"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Identityconfig().V1alpha1().IDPConfigs().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("strategies"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Identityconfig().V1alpha1().Strategies().Informer()}, nil

	}

	return nil, fmt.Errorf("no informer found for %v", resource)
}
